#include "hw_config.h"
#include "stm32_it.h"


/****************************************************************
* Function Name : SPI_FLASH_Init
* Description : Initializes the peripherals used by the SPI FLASH driver.
* Input : None
* Output : None
* Return : None
*******************************************************************/
void SPI_AD_Init(void)
{
	SPI_InitTypeDef SPI_InitStructure;
	GPIO_InitTypeDef GPIO_InitStructure;
	
	/* Enable SPI1 and GPIO clocks */
	/*!< SPI_FLASH_SPI_CS_GPIO, SPI_FLASH_SPI_MOSI_GPIO,
	SPI_FLASH_SPI_MISO_GPIO, SPI_FLASH_SPI_DETECT_GPIO
	 and SPI_FLASH_SPI_SCK_GPIO Periph clock enable */
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOD,ENABLE);
	
	/*!< SPI_FLASH_SPI Periph clock enable */
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_SPI1, ENABLE);
	/*!< AFIO Periph clock enable */
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE);
	
	/*!< Configure SPI_FLASH_SPI pins: SCK */
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	
	/*!< Configure SPI_FLASH_SPI pins: MISO */
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	
	/*!< Configure SPI_FLASH_SPI pins: MOSI */
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	
	/*!< Configure SPI_FLASH_SPI_CS_PIN pin: SPI_FLASH Card CS pin */
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4;
	
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	
	/* Deselect the FLASH: Chip Select high */
//	SPI_FLASH_CS_HIGH();
	
	/* SPI1 configuration */
	// W25X16: data input on the DIO pin is sampled on the rising edge of the CLK.
	// Data on the DO and DIO pins are clocked out on the falling edge of CLK.
	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
	SPI_InitStructure.SPI_DataSize = SPI_DataSize_16b;
	SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;
	SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;
	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_8;
	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
	SPI_InitStructure.SPI_CRCPolynomial = 7;
	SPI_Init(SPI1, &SPI_InitStructure);
	
	/* Enable SPI1 */
	SPI_Cmd(SPI1, ENABLE);

}
/****************************************************************
* Function Name : TIM5_Init
* Description : Initializes the peripherals used by the SPI FLASH driver.
* Input : None
* Output : None
* Return : None
*******************************************************************/
void TIM5_Init(void)
{
	TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
	
	/* TIM5 clock enable */
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM5, ENABLE);
	

	
	/* Time base configuration */

	/*ÿνжϷʱΪ=((1+TIM_Prescaler )/72M)*(1+TIM_Period)*/

	//ԶװصļֵڼǴ0ʼģ10000κΪ9999
	TIM_TimeBaseStructure.TIM_Period = (7200-1);

	// ԤƵϵΪ0ʱʾƵҪ1
	TIM_TimeBaseStructure.TIM_Prescaler = (9);
	// ߼Ӧñβ漰ڶʱʱ(CK_INT)Ƶ˲(ETR,TIx)
	// ʹõĲƵ֮ķƵ
	TIM_TimeBaseStructure.TIM_ClockDivision = 0;
	//ϼ
	TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;
	//ʼʱ5
	TIM_TimeBaseInit(TIM5, &TIM_TimeBaseStructure);
	
	/* Clear TIM5 update pending flag[TIM5жϱ־] */
	TIM_ClearITPendingBit(TIM5, TIM_IT_Update);
	
	/* TIM IT enable */ //ж
	TIM_ITConfig(TIM5, TIM_IT_Update, ENABLE);
	
	/* TIM5 enable counter */
	TIM_Cmd(TIM5, ENABLE);	//ʹܣʼ
}


